	cpu 286
	org 100h

%define	b	byte
%define	w	word
%define	d	dword

start:
	cli
	call	Disable
	mov	sp,ENDDRIVER+200h
	mov	bx,sp
	shr	bx,4
	inc	bx
	mov	ah,4Ah
	int	21h
	jc	Crash
;
	mov	bx,1000h
	mov	ah,48h
	int	21h
	jc	Crash

	mov	[ExeSeg],ax
	mov	[ExeSeg+2],ax
	mov	[seg1],ax
	add	ax,5a2h
	mov	[dseg],ax

	mov	dx,ExeName
	mov	bx,ExeSeg
	mov	ax,4B03h
	int	21h			;load exe as an overlay
	jc	Crash

	cli
	mov	es,[seg1]
	mov	ax,[dseg]
	mov	ds,ax
	mov	ss,ax
	mov	sp,9700h
	mov	b [es:0c7h],0cbh	;retf as most functions are near
	mov 	al,0ebh
	mov	[es:1a22h],al
	mov	[es:1a30h],al		;skip sound.rom check
	mov	b [8f34h],1		;enable sound
	mov	b [17ch],2Eh		;set cwd as 'drive'

	call	far [cs:seg1call]	;setup driver

	xor	al,al
	int	40h				;init driver

	push	cs
	pop	ds
	mov	dx,NewInt7F
	mov	ax,257Fh
	int	21h
	call	Enable
	sti
@@infyloop:
	mov	ax,9801h
	int	18h
	jmp	@@infyloop
Disable:
	mov	al,80h
	jmp	HootOut
Enable:
	mov	al,81h
HootOut:
	mov	dx,7E8h
	out	dx,al
	ret
Crash:
	cli
	mov	bx,0DEADh
	mov	cx,bx
	mov	dx,bx
@@loop1:
	jmp	@@loop1
;
NewInt7F:
	cli
	cld
	pusha
	push	ds
	push	es
	call	Disable
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	dx,7E0h
	in	al,dx
	test	al,al
	jz	@@play
	cmp	al,2
	jnz	@@exitint
	call	@@stop
@@exitint:
	call	Enable
	pop	es
	pop	ds
	popa
	iret
@@play:
	call	@@stop
	mov	dx,7E2h
	in	ax,dx
	mov	ah,al
	mov	al,2
	int	40h
	jmp	@@exitint
@@stop:
	mov	al,3
	int	40h
@@bye:
	ret
Playing	db 0
ExeName	db 'STARTUP.EXE',0
	align 2
seg1call	dw 0b9h
seg1		dw 0
dseg		dw 0
ExeSeg	dw 0,0,0
	db	13,10,13,10,"The Bard's Tale PC98 Driver v1.0 by Mok"
ENDDRIVER:

	end
